#ifndef ISOCANVAS_H
#define ISOCANVAS_H

#include <MASkinG.h>
#include "engine.h"

class IsoCanvas : public MAS::ScrollBox 
{
	protected:
		int cursor_x;
		int cursor_y;
		int scrollTimer;
		Rect cursorRect; // store to mark dirty later
	
		// Draws the starfield on the canvas.
		void DrawClientArea (MAS::Bitmap &canvas, int xofst, int yofst);
		
		virtual void MsgMousemove(const MAS::Point &d);
		virtual void MsgLPress();
		virtual void MsgTimer(int id);
	public:
		void markCanvasDirty (int x1, int y1, int w, int h);
		// the constructor just does some basic setup stuff
		IsoCanvas();
		~IsoCanvas();	
};

extern IsoCanvas *isoCanvas;
extern MAS::Label *lblDebug;

#endif
