#include "serialize.h"

using namespace std;

bool WriteInt (fstream &f, int output)
{
	f.write ((char *)(&output), sizeof (output));
	return f.good();
}

int ReadInt (fstream &f)
{
	int result;
	f.read ((char*)(&result), sizeof (result));
	return result;
}

bool WriteString (fstream &f, const std::string &output)
{
	unsigned int size = output.size();
	f.write ((char*)(&size), sizeof (size));
	f.write (output.c_str(), size);
	return f.good();
}

string ReadString (fstream &f)
{
	int size;
	char *buffer = NULL;
	bool error = false;
	if (!error)
	{
		f.read ((char*)(&size), sizeof (size));
		if (!f.good()) error = true;
		assert (size <= 60000); // sanity check
	}
	if (!error)
	{
		buffer = new char[size + 1];
		if (!buffer) error = true;
	}
	if (!error)
	{
		buffer[size] = 0; // terminate with null character
		f.read (buffer, size);
		if (!f.good()) error = true;
	}
	string result = "";
	if (!error)
	{
		result = string(buffer);
	}
	if (buffer) delete[] buffer;
	return result;
}
