#include "xmldialog.h"

using namespace std;
using namespace xdom;
using namespace MAS;

void XmlDialog::readFromXml (xdom::DomNode &n)
{
	string s = n.attributes["title"];
	title.SetText (s.c_str());

	GetClientArea()->Resize(
		atoi(n.attributes["width"].c_str()),		
		atoi(n.attributes["height"].c_str())
	);
			
	// now add widgets
	vector<DomNode>::iterator w;
	for (w = n.children.begin(); w != n.children.end(); ++w)
	{
		int width, height, left, top, id;
		string tooltiptext;
		if (w->name == "button" ||
			w->name == "label" ||
			w->name == "checkbox" ||
			w->name == "radiobutton" ||
			w->name == "panel" ||
			w->name == "listbox" ||
			w->name == "listboxex" ||
			w->name == "combobox" ||
			w->name == "editbox")
		{
			left = atoi(w->attributes["left"].c_str());
			top = atoi(w->attributes["top"].c_str());
			width = atoi(w->attributes["width"].c_str());	
			height = atoi(w->attributes["height"].c_str());
			id = atoi(w->attributes["id"].c_str());
			tooltiptext = w->attributes["tooltiptext"];
		}
		
		Widget *widget = NULL;
		if (w->name == "button")
		{
			Button *b = new Button();
			b->SetText (w->attributes["text"].c_str());			
			
			widget = b;
		}
		else if (w->name == "label")
		{
			Label *l = new Label();
			l->SetText (w->attributes["text"].c_str());			
			
			widget = l;
		}
		else if (w->name == "checkbox")
		{
			CheckBox *cb = new CheckBox();
			cb->SetText (w->attributes["text"].c_str());			
			
			widget = cb;
		}
		else if (w->name == "radiobutton")
		{
			RadioButton *rb = new RadioButton();
			rb->SetText (w->attributes["text"].c_str());			
			
			widget = rb;
		}
		else if (w->name == "panel")
		{
			Panel *p = new Panel();
			
			widget = p;
		}
		else if (w->name == "listbox")
		{
			ListBox *lb = new ListBox();
			
			lb->SetMultiSelect(true);
			//~ for (int i = 0; i < 15; i++) 
				//~ lb->InsertItem(new ListItemString("this actually works"));
			
				//~ // Setup the first list:
	//~ list1.Shape(16, 72, 320, 320);

	//~ int i;

	//~ // The list will have six columns titled "col 1", "col 2" and so on
	//~ for (i=0; i<6; i++) {
		//~ char tmp[64];
		//~ usprintf(tmp, "col %d", i+1);

		//~ // Insert the column at position i, with centre alignment of the
		//~ // column title and make it 80 pixels wide.
		//~ list1.InsertColumn(tmp, i, 2, 80);
	//~ }

	//~ // The list will have 100 items, each will contain its coordinates.
	//~ for (i=0; i<100; i++) {
		//~ // Make new item. Note that once a new item is inserted in a list,
		//~ // the list owns it and is responsible for deleting it when the
		//~ // time comes, so we don't have to remember the pointer and delete
		//~ // it later. In fact, we mustn't.
		//~ list1.InsertItem(new ListBoxEx::Item());

		//~ // Setup each column in the current item: just write coordinates in it.
		//~ for (int j=0; j<6; j++) {
			//~ char tmp[64];
			//~ usprintf(tmp, "(%d, %d)", i, j);

			//~ // We could use something like list1.GetItem(i)->SetText(tmp, j), or
			//~ // we could remember the pointer we created when inserting the item
			//~ // and use that to enter the text, but calling SetItem() is just so
			//~ // much easier.
			//~ list1.SetItem(i, j, tmp);
		//~ }
	//~ }

	//~ Add(list1);

			
			widget = lb;
		}
		else if (w->name == "listboxex")
		{
			ListBoxEx *lb = new ListBoxEx();
			
			//~ lb->SetMultiSelect(true);
			
			widget = lb;
		}
		else if (w->name == "editbox")
		{
			EditBox *eb = new EditBox();
			
			eb->SetText (w->attributes["text"].c_str());			
			widget = eb;
		}
		else if (w->name == "combobox")
		{
			ComboBox *cb = new ComboBox;
			
			cb->list.InsertItem(new ListItemString("option 1"), 0);
			cb->list.InsertItem(new ListItemString("option 2"), 1);
			cb->list.InsertItem(new ListItemString("option 3"), 2);
			cb->list.h(100);
			cb->editBox.SetFlag(D_READONLY);

			widget = cb;
		}
		
		if (widget)
		{
			widget->Shape (left, top, width, height);
			widget->SetTooltipText (tooltiptext.c_str());				
			widget->SetCallbackID(id);
			Add (*widget);
			widgets.insert (pair<int, Widget*> (id, widget));
		}
	}
}
